package org.openepics.names.rest.beans.element;

import java.io.Serializable;
import java.util.Objects;
import java.util.UUID;

import io.swagger.v3.oas.annotations.media.Schema;

public class NameElementCommandConfirm implements Serializable {

    /**
     *
     */
    private static final long serialVersionUID = 7227646902292017096L;

    @Schema(description = "Identity (uuid) of the name entry. Value is created server-side.")
    private UUID uuid;
    @Schema(description = "Comment of the name entry command.")
    private String comment;

    /**
     * Public constructor.
     */
    public NameElementCommandConfirm() {
    }

    /**
     * Public constructor.
     *
     * @param uuid uuid
     * @param comment comment
     */
    public NameElementCommandConfirm(
            UUID uuid, String comment) {
        super();
        this.uuid = uuid;
        this.comment = comment;
    }

    public UUID getUuid() {
        return uuid;
    }
    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }
    public String getComment() {
        return comment;
    }
    public void setComment(String comment) {
        this.comment = comment;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;

        return equals ((NameElementCommandConfirm) obj);
    }

    public boolean equals(NameElementCommandConfirm other) {
        if (other == null)
            return false;

        if (!super.equals(other)) {
            return false;
        }

        if (getUuid() == null) {
            if (other.getUuid() != null)
                return false;
        } else if (!getUuid().equals(other.getUuid()))
            return false;
        if (getComment() == null) {
            if (other.getComment() != null)
                return false;
        } else if (!getComment().equals(other.getComment()))
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        return Objects.hash(getUuid());
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        sb.append("\"uuid\": "                    + getUuid());
        sb.append(", \"comment\": "               + getComment());
        sb.append("}");
        return sb.toString();
    }

}
