package org.openepics.names.rest.beans.element;

import java.io.Serializable;
import java.util.Objects;
import java.util.UUID;

import org.openepics.names.rest.beans.Type;

import io.swagger.v3.oas.annotations.media.Schema;

public class StructureElementCommandUpdate extends StructureElementCommandCreate implements Serializable {

    /**
     *
     */
    private static final long serialVersionUID = -3346987084345524300L;

    @Schema(description = "Identity (uuid) of the structure entry. Value is created server-side.")
    private UUID uuid;

    /**
     * Public constructor.
     */
    public StructureElementCommandUpdate() {
    }

    /**
     * Public constructor.
     *
     * @param uuid uuid
     * @param type type
     * @param parent parent uuid
     * @param name name
     * @param mnemonic mnemonic
     * @param description description
     * @param comment comment
     */
    public StructureElementCommandUpdate(
            UUID uuid, Type type, UUID parent,
            String name, String mnemonic,
            String description, String comment) {
        super(type, parent, name, mnemonic, description, comment);
        this.uuid = uuid;
    }

    public UUID getUuid() {
        return uuid;
    }
    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null)
            return false;
        if (getClass() != obj.getClass())
            return false;

        return equals ((StructureElementCommandUpdate) obj);
    }

    public boolean equals(StructureElementCommandUpdate other) {
        if (other == null)
            return false;

        if (!super.equals(other)) {
            return false;
        }

        if (getUuid() == null) {
            if (other.getUuid() != null)
                return false;
        } else if (!getUuid().equals(other.getUuid()))
            return false;

        return true;
    }

    @Override
    public int hashCode() {
        return Objects.hash(getUuid());
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append("{");
        sb.append("\"uuid\": "                    + getUuid());
        sb.append(", \"type\": "                  + getType());
        sb.append(", \"parent\": "                + getParent());
        sb.append(", \"name\": "                  + getName());
        sb.append(", \"mnemonic\": "              + getMnemonic());
        sb.append(", \"description\": "           + getDescription());
        sb.append(", \"comment\": "               + getComment());
        sb.append("}");
        return sb.toString();
    }

}
